# AgentDojo

## Quickstart

```bash
pip install agentdojo
```

If you want to use the PI detector, you need to install the `transformers` extra:

```bash
pip install "agentdojo[transformers]"
```

## Leaderboard

TODO add leaderboard here!

## Running the benchmark

To run the benchmark, you need to install the package.

The benchmark can be run with the [benchmark](https://github.com/ethz-spylab/agentdojo/blob/main/src/agentdojo/scripts/benchmark.py) script. Documentation on how to use the script can be obtained with the `--help` flag.

For example, to run the `workspace` suite on the tasks 0 and 1, with `gpt-4o-2024-05-13` as the LLM, the tool filter as a defense, and the attacker with tool knowlege, run the following command:

```bash
python -m agentdojo.scripts.benchmark -s workspace -ut user_task_0 \
    -ut user_task_1 --model gpt-4o-2024-05-13 \
    --defense tool_filter --attacker tool_knowledge
```

To run the above, but on all suites and tasks, run the following:

```bash
python -m agentdojo.scripts.benchmark --model gpt-4o-2024-05-13 \
    --defense tool_filter --attacker tool_knowledge
```

## How do I create a new defense or model?

Check out the [documentation](concepts/agent_pipeline.md) on how to create your own pipeline.

## How do I create a new attack?

Check out the [documentation](concepts/attacks.md) on attacks.

## How can I use the Dojo to create my own benchmark?

Take a look at our in-depth [documentation](concepts/task_suite_and_tasks.md) on how to create a new task suite.

## Development set-up

Take a look at the [development set-up](development.md) docs.
